# Schematron validation

## 1. Introduction 

Within OOTS-EDM some examples for the evidence exchange using the OOTS Exchange Data Model are provided. The samples can be used for sending and receiving evidences using the mechanisms defined in the specifications of the [Once-Only Technical System (OOTS)](https://ec.europa.eu/cefdigital/wiki/display/CEFDIGITAL/Once+Only+Principle) developed for the EU's [Single Digital Gateway regulation](https://ec.europa.eu/growth/single-market/single-digital-gateway_en). 
 The XML samples (Evidence Request-Response, DSD, EB and LCM) can be found in the [OOTS-EDM/XML folder of the tdd_chapters git repository](https://code.europa.eu/oots/tdd/tdd_chapters/-/tree/e49131e193760a7527ade3f207b1f3a037ac0c56/OOTS-EDM/xml).


## 2. Business Rules
A set of [Business Rules](https://code.europa.eu/oots/tdd/tdd_chapters/-/tree/master/OOTS-EDM/xlsx) is defined which must be applied in each transaction (Evidence Request-Reponse, EB, DSD, LCM). For each business rule, a corresponding schematron rule is defined that references the same rule ID. The business rules are sets of rules that guarantee the correct structure of the transactions and they clarify the content of instances by stating mandatory fields, fixed values (like code lists), the dependency between fields in the same object and dependency between different objects. The business rules are grouped into two main sections depending on their scope..


					
## 3. Schematron files
Schematron is used for validating the Business Rules. Schematron validation files are available here: [Schematron Files](https://code.europa.eu/oots/tdd/tdd_chapters/-/tree/master/OOTS-EDM/sch). There are two types of Business Rules:
   * Structure: Business rules that guarantee the correct structure of the message:
Check information constraints related to the use of different components such as namespaces, root elements, slots, data types including "multidimensional" checks crossing the barrier between the different XSD schemes (XSD-Binding and XSD-Restriction).
   * Content: Business rules that ensure the correct content format of information objects:
Check cardinalities, identifiers, formats, fixed values, mandatory set of values on specific fields (code lists) and dependencies between fields;

A specific XML sample like an [Evidence Request](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/xml/Request-Response%20Samples/4.5.4%20-%20OOTS-EDM%20XML%20Examples%20of%20the%20Evidence%20Exchange/2%20Example%20for%20requesting%20a%20Birth%20Certificate%20-%20natural%20person/2.1%20Step%201%20%20Evidence%20Request%20-%20Birth%20-%20full%20example.xml):
* Should be validated for the structure by using the structure schematron file [EDM-REQ-S.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EDM-REQ-S.sch) and 
* Should be validated for the contents by using the content schematron file [EDM-REQ-C.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EDM-REQ-C.sch)

The following table describes the business rule component and the schematron files used for validation.

     
| ID           | Transaction                                   | Validation type | Description                                                                                        | Version | Component    | SCH validation file | File location                                                                                                                                                                        
|--------------|-----------------------------------------------| --------------- |----------------------------------------------------------------------------------------------------|---------| ------------ | ------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ 
| EDM-ebMS     | ebMS Message Header                           | Global          | Business Rules of 'ebMS Message Header' for Evidence Exchange                                      | 1.0.4   | EDM          | EDM-ebMS.sch        | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EDM-ebMS.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EDM-ebMS.sch)         
| EDM-REQ-C    | Evidence Request                              | Contents        | Business Rules to validate the contents of 'Evidence Request Syntax Mapping'                       | 1.1.0   | EDM          | EDM-REQ-C.sch       | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EDM-REQ-C.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EDM-REQ-C.sch)       
| EDM-REQ-S    | Evidence Request                              | Structure       | Business Rules to validate the structure of 'Evidence Request Syntax Mapping'                      | 1.1.0   | EDM          | EDM-REQ-S.sch       | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EDM-REQ-S.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EDM-REQ-S.sch)       
| EDM-RESP-C   | Evidence Response                             | Contents        | Business Rules to validate the contents of 'Evidence Response Syntax Mapping'                      | 1.1.0  | EDM          | EDM-RESP-C.sch      | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EDM-RESP-C.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EDM-RESP-C.sch)     
| EDM-RESP-S   | Evidence Response                             | Structure       | Business Rules to validate the structure of 'Evidence Response Syntax Mapping'                     | 1.1.0   | EDM          | EDM-RESP-S.sch      | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EDM-RESP-S.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EDM-RESP-S.sch)     
| EDM-ERR-C    | EDM Error Response                            | Contents        | Business Rules to validate the contents of 'Error Response Syntax Mapping'                         | 1.1.0  | EDM          | EDM-ERR-C.sch       | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EDM-ERR-C.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EDM-ERR-C.sch)       
| EDM-ERR-S    | EDM Error Response                            | Structure       | Business Rules to validate the structure of 'Error Response Syntax Mapping'                        | 1.1.0   | EDM          | EDM-ERR-S.sch       | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EDM-ERR-S.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EDM-ERR-S.sch)       
| DSD-RESP-C   | DSD Query Response                            | Contents        | Business Rules to validate the contents of 'Query Response of the DSD'                             | 1.1.0   | DSD          | DSD-RESP-C.sch      | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/DSD-RESP-C.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/DSD-RESP-C.sch)     
| DSD-RESP-S   | DSD Query Response                            | Structure       | Business Rules to validate the structure of 'Query Response of the DSD'                            | 1.1.0  | DSD          | DSD-RESP-S.sch      | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/DSD-RESP-S.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/DSD-RESP-S.sch)     
| DSD-ERR-C    | DSD Error Response                            | Contents        | Business Rules to validate the contents of 'Query Error Response of the DSD'                       | 1.1.0   | DSD          | DSD-ERR-C.sch       | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/DSD-ERR-C.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/DSD-ERR-C.sch)       
| DSD-ERR-S    | DSD Error Response                            | Structure       | Business Rules to validate the structure of 'Query Error Response of the DSD'                      | 1.1.0   | DSD          | DSD-ERR-S.sch       | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/DSD-ERR-S.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/DSD-ERR-S.sch)         
| DSD-SUB_RF-C | LCM Submit Objects to DSD (Refactored)        | Contents        | Business Rules to validate the contents of 'LCM Submit Registry Objects to the DSD (Refactored)'   | 1.1.0   | DSD (LCM)    | DSD-SUB_RF-C.sch    | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/DSD-SUB_RF-C.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/DSD-SUB_RF-C.sch) 
| DSD-SUB_RF-S | LCM Submit Objects to DSD (Refactored)        | Structure       | Business Rules to validate the structure of 'LCM Submit Registry Objects to the DSD (Refactored)'  | 1.1.0   | DSD (LCM)    | DSD-SUB_RF-S.sch    | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/DSD-SUB_RF-S.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/DSD-SUB_RF-S.sch) 
| EB-REQ-C     | EB Query Response for the "Requirement Query" | Contents        | Business Rules to validate the contents of 'Query Response of the EB for the "Requirement Query"'  | 1.1.0   | EB           | EB-REQ-C.sch        | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EB-REQ-C.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EB-REQ-C.sch)         
| EB-REQ-S     | EB Query Response for the "Requirement Query" | Structure       | Business Rules to validate the structure of 'Query Response of the EB for the "Requirement Query"' | 1.1.0   | EB           | EB-REQ-S.sch        | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EB-REQ-S.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EB-REQ-S.sch)         
| EB-EVI-C     | EB Query Response for the "Evidence Types"    | Contents        | Business Rules to validate the contents of 'Query Response of the EB for the "Evidence Types"'     | 1.1.0   | EB           | EB-EVI-C.sch        | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EB-EVI-C.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EB-EVI-C.sch)         
| EB-EVI-S     | EB Query Response for the "Evidence Types"    | Structure       | Business Rules to validate the structure of 'Query Response of the EB for the "Evidence Types"'    | 1.1.0   | EB           | EB-EVI-S.sch        | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EB-EVI-S.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EB-EVI-S.sch)         
| EB-ERR       | EB Error Response                             | Global          | Business Rules to validate the 'Query Error Response of the EB'                                    | 1.1.0  | EB           | EB-ERR.sch          | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EB-ERR.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EB-ERR.sch)             
| EB-SUB-C     | LCM Submit Objects to EB                      | Contents        | Business Rules to validate the contents of 'LCM Submit Registry Objects to the EB'                 | 1.1.0   | EB (LCM)     | EB-SUB-C.sch        | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EB-SUB-C.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EB-SUB-C.sch)         
| EB-SUB-S     | LCM Submit Objects to EB                      | Structure       | Business Rules to validate the structure of 'LCM Submit Registry Objects to the EB'                | 1.1.0   | EB (LCM)     | EB-SUB-S.sch        | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EB-SUB-S.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/EB-SUB-S.sch)      
| LCM-ERR      | LCM Error Response                            | Global          | Business Rules to validate the 'Regrep LCM Error Response'                                         | 1.1.0   | EB/DSD (LCM) | LCM-SUC.sch         | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/LCM-ERR.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/LCM-ERR.sch)   
| LCM-SUC      | LCM Successfull Response                      | Global          | Business Rules to validate the 'Regrep LCM Successful Response'                                    | 1.1.0   | EB/DSD (LCM) | LCM-SUC.sch         | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/LCM-SUC.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/LCM-SUC.sch)           
| LCM-SUB-S    | LCM Submit EB and DSD                         | Structure (For Contents Validation DSD-SUB_RF-C.sch and EB-SUB-C.sch are used)     | Business Rules to validate the structure of 'LCM Submit Registry Objects to the EB and DSD'        | 1.1.0   | EB and DSD (LCM)  | LCM-SUB-S.sch     | [https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/LCM-SUB-S.sch](https://code.europa.eu/oots/tdd/tdd_chapters/-/blob/master/OOTS-EDM/sch/LCM-SUB-S.sch) 